PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
#DAEMON=/home/build/dingyujun/UniVPN/promote/UniVPNPromoteService
SERVICEPATH=/usr/local/UniVPN/promote
SPESRESMON=/usr/local/spes/spesresmon
SPESRESMON2=spesresmon
NAME=UniVPNPromoteService
DESC="UniVPNPromoteService daemon"

test -x $DAEMON || exit 0

#begin only for kylin
VERSION=$(awk -F= '/^DISTRIB_ID/{print $2}' /etc/*-release)
#echo "$VERSION"
if [ "$VERSION" = "Kylin" ]; then
    CORE_ARRAY=(core_sogouImeService core_kylin-window-sw core_pulseaudio core_QDBusConnection core_QXcbEventReader core_kglobalaccel5 core_kylin-kmre-mana core-kylin-kmre-apps core_kylin-nm core_QXcbEventQueue)
    CORE_ARRAY_NUMS=${#CORE_ARRAY[@]}
    #echo "$CORE_ARRAY_NUMS"
    #APP="UniVPN"
    DUMPPATH=$SERVICEPATH/../log
    #echo "$DUMPPATH"
    cd $DUMPPATH
    result=$(find . ! -name "." -type d -prune -o -type f -name "*.core" -print)
    #echo "find reault is $result"
    result=${result//;/$'\n'}
    for core in $result
    do
        #echo "dump file is $core"
#删除kylin系统中日志目录下产生的与UniVPN不相关的core文件
        #if [ $core != *$APP* ]
	#then
            #echo "delete $core"
        #    rm -rf $core
        #fi
#删除kylin系统中日志目录下产生的包含数组元素名字的core文件
	for n in ${CORE_ARRAY[*]}
	do
	    #echo "core_name is $n"
	    if [[ $core = *$n* ]]; then
	        rm -rf $core
		#echo "*$n*"
		break
	    fi
	done
    done
fi
#end only for kylin

RUN=no
RUN_AS_USER=root
DAEMON_OPTS="-d"
OS=`cat /etc/*-release`
if [ "$OS" = "Ubuntu" ]; then #ubuntu启动过程
    case "$1" in
    start)
        echo -n "Starting $DESC: "
        start-stop-daemon --start --quiet --pidfile /var/run/$NAME.pid \
        -d `dirname $DAEMON` --exec $DAEMON -- $DAEMON_OPTS
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        start-stop-daemon --stop --oknodo --quiet --exec $DAEMON #$SPESRESMON
        pkill -9 $NAME 
        echo "$NAME."
        ;;
    force-reload)
        # check whether $DAEMON is running. If so, restart
        start-stop-daemon --stop --test --quiet --pidfile \
            /var/run/$NAME.pid --exec $DAEMON \
        && $0 restart \
        || exit 0
        ;;
    restart)
        echo -n "Restarting $DESC: "
        start-stop-daemon --stop --oknodo --quiet --exec $SPESRESMON
        pkill -9 $NAEM 
        sleep 2
        start-stop-daemon --start --quiet --pidfile \
        /var/run/$NAME.pid -d `dirname $DAEMON` --exec $DAEMON -- $DAEMON_OPTS
        echo "$NAME."
        ;;
    status)
        if [ -s /var/run/$NAME.pid ]; then
                RUNNING=$(cat /var/run/$NAME.pid)
                if [ -d /proc/$RUNNING ]; then
                    if [ $(readlink /proc/$RUNNING/exe) = $DAEMON ]; then
                        echo "$NAME is running."
                        exit 0
                    fi
                fi

                # No such PID, or executables don't match
                echo "$NAME is not running, but pidfile existed."
                rm /var/run/$NAME.pid
                exit 1
            else
                rm -f /var/run/$NAME.pid
                echo "$NAME not running."
                exit 1
            fi
        ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
    esac
    exit 0
else      #redhat启动过程
    case "$1" in
    start)
        echo -n "Starting $DESC: "
        cd $SERVICEPATH
        ./$NAME &
        echo "$NAME."
        ;;
    stop)
        echo -n "Stopping $DESC: "
        kill -9 $(ps -ef | grep UniVPNPromoteService | grep -v grep | awk '{print $2}')
        echo "$NAME."
        ;;
    force-reload)
        # check whether $DAEMON is running. If so, restart
        kill -9 $(ps -ef | grep UniVPNPromoteService | grep -v grep | awk '{print $2}')\
        && $0 restart \
        || exit 0
        ;;
    restart)
        echo -n "Restarting $DESC: "
        kill -9 $(ps -ef | grep UniVPNPromoteService | grep -v grep | awk '{print $2}') 
        sleep 2
        cd $SERVICEPATH
        ./$NAME &
        echo "$NAME."
        ;;
    status)
        if [ -s /var/run/$NAME.pid ]; then
                RUNNING=$(cat /var/run/$NAME.pid)
                if [ -d /proc/$RUNNING ]; then
                    if [ $(readlink /proc/$RUNNING/exe) = $DAEMON ]; then
                        echo "$NAME is running."
                        exit 0
                    fi
                fi

                # No such PID, or executables don't match
                echo "$NAME is not running, but pidfile existed."
                rm /var/run/$NAME.pid
                exit 1
            else
                rm -f /var/run/$NAME.pid
                echo "$NAME not running."
                exit 1
            fi
        ;;
    *)
        N=/etc/init.d/$NAME
        echo "Usage: $N {start|stop|restart|force-reload}" >&2
        exit 1
        ;;
    esac
    exit 0
fi

